package question

import (
	"context"

	"gitea.dwysokinski.me/zdam-egzamin-zawodowy/backend/internal/model"
)

type Usecase interface {
	Store(ctx context.Context, input *model.QuestionInput) (*model.Question, error)
	UpdateOneByID(ctx context.Context, id int, input *model.QuestionInput) (*model.Question, error)
	Delete(ctx context.Context, f *model.QuestionFilter) ([]*model.Question, error)
	Fetch(ctx context.Context, cfg *FetchConfig) ([]*model.Question, int, error)
	GetByID(ctx context.Context, id int) (*model.Question, error)
	GenerateTest(ctx context.Context, cfg *GenerateTestConfig) ([]*model.Question, error)
}
